# Copyright 2021 The Tekton Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    Tekton

    Tekton Pipeline  # noqa: E501

    The version of the OpenAPI document: v0.17.2
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tekton_pipeline.configuration import Configuration


class V1beta1TimeoutFields(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        '_finally': 'V1Duration',
        'pipeline': 'V1Duration',
        'tasks': 'V1Duration'
    }

    attribute_map = {
        '_finally': 'finally',
        'pipeline': 'pipeline',
        'tasks': 'tasks'
    }

    def __init__(self, _finally=None, pipeline=None, tasks=None, local_vars_configuration=None):  # noqa: E501
        """V1beta1TimeoutFields - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.__finally = None
        self._pipeline = None
        self._tasks = None
        self.discriminator = None

        if _finally is not None:
            self._finally = _finally
        if pipeline is not None:
            self.pipeline = pipeline
        if tasks is not None:
            self.tasks = tasks

    @property
    def _finally(self):
        """Gets the _finally of this V1beta1TimeoutFields.  # noqa: E501


        :return: The _finally of this V1beta1TimeoutFields.  # noqa: E501
        :rtype: V1Duration
        """
        return self.__finally

    @_finally.setter
    def _finally(self, _finally):
        """Sets the _finally of this V1beta1TimeoutFields.


        :param _finally: The _finally of this V1beta1TimeoutFields.  # noqa: E501
        :type: V1Duration
        """

        self.__finally = _finally

    @property
    def pipeline(self):
        """Gets the pipeline of this V1beta1TimeoutFields.  # noqa: E501


        :return: The pipeline of this V1beta1TimeoutFields.  # noqa: E501
        :rtype: V1Duration
        """
        return self._pipeline

    @pipeline.setter
    def pipeline(self, pipeline):
        """Sets the pipeline of this V1beta1TimeoutFields.


        :param pipeline: The pipeline of this V1beta1TimeoutFields.  # noqa: E501
        :type: V1Duration
        """

        self._pipeline = pipeline

    @property
    def tasks(self):
        """Gets the tasks of this V1beta1TimeoutFields.  # noqa: E501


        :return: The tasks of this V1beta1TimeoutFields.  # noqa: E501
        :rtype: V1Duration
        """
        return self._tasks

    @tasks.setter
    def tasks(self, tasks):
        """Sets the tasks of this V1beta1TimeoutFields.


        :param tasks: The tasks of this V1beta1TimeoutFields.  # noqa: E501
        :type: V1Duration
        """

        self._tasks = tasks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1beta1TimeoutFields):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1beta1TimeoutFields):
            return True

        return self.to_dict() != other.to_dict()
